
// ****************************************************************
// Sketch Esp32 Webserver Modular(Tab)
// created: Jens Fleischer, 2018-07-06
// last mod: Jens Fleischer, 2018-09-21
// For more information visit: https://fipsok.de
// ****************************************************************
// Hardware: Esp32
// Getestet auf: ESP32 Dev Module
/******************************************************************
  Copyright (c) 2018 Jens Fleischer. All rights reserved.

  This file is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  This file is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
*******************************************************************/
// Der WebServermodular stellt den Haupt Tab dar.
// #include "SPIFFS.h" #include <WebServer.h> müssen im Haupttab aufgerufen werden
// Die Funktionalität des ESP32 Webservers ist erforderlich.
// "server.onNotFound()" darf nicht im Setup des ESP32 Webserver stehen.
// Inklusive Arduino OTA-Updates
/**************************************************************************************/

#include <WebServer.h>
#include <ArduinoOTA.h>
#include <SPIFFS.h>
#include <WebSocketsServer.h>     // added DR

#define DEBUG             // Auskommentieren wenn keine Serielle Ausgabe erforderlich ist
#ifdef DEBUG
boolean debug = true;             // added DR for other modules
#define DEBUG_PRINT(str) \
  Serial.printf("Funktion: %s meldet in Zeile: %d -> ", __PRETTY_FUNCTION__, __LINE__);\
  Serial.println(str);
#endif

// added for LED support - DR
#define LEDext 4
  int dimmvalue;
  int CalcValue;
  String dimmer = "dimm=";
// add end

WebServer server(80);
WebSocketsServer webSocket = WebSocketsServer(81);      // added DR

void setup() {
  Serial.begin(115200);
  Serial.printf("\nSketchname: %s\nBuild: %s\n", (__FILE__), (__TIMESTAMP__));
  if (debug ) Serial.println("Debug switched on");
 
  spiffs();
  admin();
  Connect();
  LED_start();
  //setupTime();
  //espboardLed();
  //onboardLed();
  //dht22();             // Die Tabs die du nutzen möchtest, musst du Einkommentieren
  //bme280();
  //bh1750();

  ArduinoOTA.onStart([]() {
    //speichern();                  //Einkommentieren wenn Werte vor dem Update gesichert werden sollen
  });
  ArduinoOTA.begin();
  server.begin();
  webSocket.begin();                    // added DR
  webSocket.onEvent(webSocketEvent);    // added DR
#ifdef DEBUG
  printf("HTTP Server gestartet\n\n");
#endif
}

void loop () {
  ArduinoOTA.handle();
  webSocket.loop();             // added DR
  server.handleClient();
  reStation();

  if (millis() < 0x2FFF || millis() > 0xFFFFF0FF) {   // für Admin Tab
    runtime();
  }
}



